/* AppDelegate */

#import <Cocoa/Cocoa.h>
#import "PhotoLib.h"
#import "TransformedImageController.h"
#import "TransformedImageView.h"
#import "PSTransmit.h"
#import "PixieController.h"
#import "PSPhotosView.h"

@interface AppDelegate : NSObject
	{
	IBOutlet TransformedImageView * testImg; 
	
	IBOutlet NSProgressIndicator * appWait;
	
	IBOutlet TransformedImageView * mainImageView;
	IBOutlet TransformedImageController *  mainImageViewController;
	IBOutlet PixieController * pixDust;
	IBOutlet NSWindow  * orderWindow;
	IBOutlet NSWindow  * stampWindow;
	
	IBOutlet PSPhotosView * photoList;
	IBOutlet NSScrollView * photoListScroll;
	
	IBOutlet NSTableView * orderTable;
	IBOutlet NSTextField * stampValueText;
	IBOutlet NSImageView * stampBackgroundImage;
	IBOutlet NSTextField * stampBorder;
	IBOutlet NSTextField * photoCountTF;
	IBOutlet NSTextField * colorWarningField;
	
	IBOutlet NSColorWell * stampColor;
	IBOutlet NSPopUpButton * stampValueButton;
	IBOutlet NSPopUpButton * photoListPopup;
	
	IBOutlet NSImageView * stampStrikeThru;
	
	//	About Window / VERSION #
	IBOutlet NSTextField * aboutVersion;

	//	Order Window
	IBOutlet NSButton * btnContinue;							//	Set default button
	IBOutlet NSProgressIndicator * orderProgress;	//	Spinner to let them know how far we are
	IBOutlet NSTextField * orderStatus;				//	 Status indicator on order window
	NSString * orderSessionID;						//	Returned from server after we upload one image
	NSData * orderData;								//	Data returned from transmit session
	int orderRequestNextTransmit;					//	usually ZERO -- if non zero, transmitdone will call TransmitProcess w. that next #...

	NSString * _uploadFilename;		//	set in startup code

	//	iPhoto Processing
	//	-----------------
	NSXMLParser * _parser;
	int _currentPrimaryKey;
	NSString * _currentKey;
	NSMutableString * _currentStringValue;
	int openKey;
	int openString;
	PhotoLib * iPhotoPhoto;
// Defined KEYS we want to extract from the iPhoto library
	#define	PK_None  0
	#define PK_MasterList 1
	#define PK_AlbumList 2

	
	NSMutableArray * iPhotoArray;	//	Currently active iPhoto XML build of a DB
	NSString * iPhotoAlbumName;		//	for iPhoto, the album name.  For folders, 'folder'
	
	
	//	PostageAmount visual recalc based on value of stamp (3 digit vs. 2 digit)
	int initialTextPos;				//	Instance var for tracking multiple text field sizes

	
	//	IN MEMORY
	//	These represent the LIST of images, their albums and the active album and photo
	PhotoLib * activePhoto;				//	Currently ACTIVE photo
	NSString * activeAlbumName;			//	Current ACTIVE album name
	NSMutableDictionary * photoDict;	//	Photo objects locatable by ID of iPhoto or (filename in Folders).  Contains photoLib objects.
	NSMutableDictionary * photoFolders;	//	Arrays within each sub-folder for iPhoto -- albumname index w/ an array of ID's to cross reference to photoDict
	
	
	//	In-memory ORDER
	NSMutableArray * photoOrders;		//	Contains photoLib objects of current order
	
	}
	
//	Stamp Design
	- (IBAction)stampValueChange:(id)sender;	
	
	
	// - (IBAction) popHelp : (id) sender;

	- (IBAction)stampColorChange:(id)sender;	

//		Start Order Processing
	- (IBAction)endOrderWindow:(id)sender;
	- (IBAction)placeOrder:(id)sender;
	- (IBAction)transmitButton:(id)sender;
	- (void) orderRecalc;
	- (void) transmitDone:(NSNotification *)note;	//	receives the 'done' messages from the server
	- (void) transmitProcess:(int)processID;		//	sequential transmission engine for generating conections

	- (void)sheetDidEnd:(NSWindow *)sheet
			returnCode:(int)returnCode
			contextInfo:(void *)contextInfo;

	//	Combobox for photo library
- (void) changeAlbumInternal:(NSString *)selTitle;
- (IBAction)changeAlbum:(NSMenuItem *)sender;

	//	Accept Paste Image / Creates a photoObject from the image and sets it active
- (void)incomingImage:(NSImage *)image;
- (void)imageDropped:(NSNotification *)note;


	//	File Open Dialog
- (void)openPanelDidEnd:(NSOpenPanel *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;

- (void)parseiPhotoXML:(NSString *)pathToFile;

	//	PhotoLibrary view
- (int) picViewNumberOfPictures;
- (NSImage *) picViewGetPictureNumber: (int)picNum;
- (void)picViewSelected:(int)picNum;

			 //	test button
- (IBAction) updateOutputWindow:(id)sender;


@end
