/* PSTransmit */

#import <Cocoa/Cocoa.h>
#import <CoreFoundation/CoreFoundation.h>
#import <CoreServices/CoreServices.h>

//	The purpose of this is to hide all the crud required to post 
//	data (binary or text) and set some headers (or, not...)

@interface PSTransmit : NSObject
{    
	NSMutableDictionary * responseHeaders;
	NSMutableData * responseData;
	
	
	IBOutlet NSProgressIndicator * progress;
    
    CFReadStreamRef		_stream;

	NSString * statusString;
	int status;		//	1 = successs
					//	0 for inprogresssuccess.  negative for failure
					//	-1 already running something
					//	-2 bad URL set / not set at all
					//	-3 bad data set
					//	-4 failed to create stream
					//	-5 failed to link stream to an event handler
					//	-10 failed to connect to destination URL
					//	-11 error during transfer, check statusString
	
}
- (int)status;
- (NSString *)statusMsg;

- (void)post:(NSURL *)pURL postData:(NSData *)pData header:(NSDictionary *)pHeader;
- (void)postNew:(NSURL *)pURL postData:(NSData *)pData header:(NSDictionary *)pHeader;

- (void)setProgress:(NSProgressIndicator *)p;	//	set the progress indicator pointer to update

- (void)handleNetworkEvent:(CFStreamEventType)type;
- (void)handleBytesAvailable;
- (void)handleStreamComplete;
- (void)handleStreamError;

-(NSMutableData *)responseData;
-(NSDictionary *)responseHeaders;


@end
